using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_Mythos._0_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Mythos.General;

namespace Exferia_Mythos._3_Vistas.Listados
{
    public class ABS_Listado_MYT_InstalacionesLineasContratos : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MYT_InstalacionesLineasContratos()
        {
            RellenarColumnas();
        }

        private void RellenarColumnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //numero
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.numero), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.numero), "Número", G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null, false));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.descripcion), "Descripción", G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null, false));

            //fechaInicio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.fechaInicio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.fechaInicio), "Fecha inicio", G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, true, true, false, "", null));

            //fechaFin
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.fechaFin), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.fechaFin), "Fecha fin", G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, false, false, false, "", null,true));

            //observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.observaciones), "Observaciones", G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null, true));

            //TIPOCONTRATO.......................................
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_TIPOCONTRATO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.idTipoContrato), nameof(MYT_TiposContratos), nameof(MYT_TiposContratos.id), nameof(MYT_TiposContratos.codigo), nameof(MYT_TiposContratos.descripcion), nameof(MYT_TiposContratos.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.TipoContrato), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.TipoContrato), "Tipo de contrato", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_TIPOCONTRATO));
            //..............................................

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MYT_INSTALACIONESLINEASCONTRATOS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MYT_INSTALACIONESLINEASCONTRATOS;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MYT_InstalacionesLineasContratos_Listado_Modelo.fechaInicio);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "1";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
